// SPDX-License-Identifier: GPL-2.0

#include <linux/module.h>
#include <linux/init.h>
#include <linux/mod_devicetable.h>
#include <linux/property.h>
#include <linux/platform_device.h>
#include <linux/of_device.h>
#include <linux/gpio/consumer.h>
#include <linux/proc_fs.h>


/* Declare the probe and remove function */
static int dt_probe(struct platform_device *pdev);
static int dt_remove(struct platform_device *pdev);

static struct of_device_id my_driver_ids[] =
{
	{
		.compatible = "brightlight,mydev",
	}, { /* sentinal */}
};
MODULE_DEVICE_TABLE(of, my_driver_ids);

static struct platform_driver my_driver = {
	.probe = dt_probe,
	.remove = dt_remove,
	.driver = {
		.name = "my_device_driver",
		.of_match_table = my_driver_ids,
	},
};


/* GPIO variable */
static struct gpio_desc *my_led = NULL;

static struct proc_dir_entry *proc_file;

/**
 * @brief write data to buffer
 */
static ssize_t my_write(struct file *file, const char *user_buffer, size_t count, loff_t *offs)
{
	switch (user_buffer[0]){
		case '0' :
		case '1' :
			gpiod_set_value(my_led, user_buffer[0] - '0');
		default:
			break;
	}
	return count;
}


static struct proc_ops fops = {
	.proc_write = my_write,
};

/**
 * @brief This function is called on loading the driver
 */
static int dt_probe(struct platform_device *pdev)
{
	struct device *dev = &pdev->dev;
	const char *label;
	int my_value, ret;

	pr_info("dt_gpio - Now I am in the probe function");

	/* check for device properties */
	if(!device_property_present(dev, "label"))
	{
		pr_err("dt_gpio - Error! Device property 'label' not found\n");
		return -1;
	}
	if(!device_property_present(dev, "my_value"))
	{
		pr_err("dt_gpio - Error! Device property 'my_value' not found\n");
		return -1;
	}
	if(!device_property_present(dev, "green-led-gpio"))
	{
		pr_err("dt_gpio - Error! Device property 'green-led-gpios' not found\n");
		return -1;
	}
	if(!device_property_present(dev, "led-gpios"))
	{
		pr_err("dt_gpio - Error! Device property 'led-gpios' not found\n");
		return -1;
	}

	/* Read device properties */
	ret = device_property_read_string(dev, "label", &label);
	if(ret)
	{
		pr_err("dt_gpio - Error! could not read 'label'\n");
		return -1;
	}
	pr_info("dt_gpio - Label: %s\n", label);
	ret = device_property_read_u32(dev, "my_value", &my_value);
	if(ret)
	{
		pr_err("dt_gpio - Error! could not read 'my_value'\n");
		return -1;
	}
	pr_info("dt_gpio - 'my_value': %d\n", my_value);
	

	/* Init GPIO */
	my_led = gpiod_get(dev, "green-led", GPIOD_OUT_LOW);
	if(IS_ERR(my_led))
	{

		pr_err("dt_gpio - Error! could not read 'led'\n");
		return -1 * IS_ERR(my_led);
	}
	

	/* Creating procfs file */
	proc_file = proc_create("my-led", 0666, NULL, &fops);
	if(proc_file == NULL)
	{
		pr_err("dt_gpio - Error creating /proc/my-led\n");
		gpiod_put(my_led);
		return -ENOMEM;
	}
	pr_info("dt_gpio - Created /proc/my-led\n");
	return 0;
}

/**
 * @brief This function is called on unloading the driver
 */
static int dt_remove(struct platform_device *pdev)
{
	pr_info("dt_gpio - Now I am in the remove function");
	gpiod_put(my_led);
	proc_remove(proc_file);
	return 0;
}

/**
 * @brief This function is called when the module is loaded into the kernel
 */
static int __init my_init(void)
{
	pr_notice("dt_gpio - Loading the driver ...\n");
	if(platform_driver_register(&my_driver))
	{
		pr_err("dt_gpio - Error! could not load driver\n");
		return -1;
	}
	return 0;
}

/**
 * @brief This function is called when the module is removed from the kernel
 */
static void __exit my_exit(void)
{
	pr_info("Goodbye, Kernel\n");
	platform_driver_unregister(&my_driver);
}

module_init(my_init);
module_exit(my_exit);

/* Meta Information */
MODULE_LICENSE("GPL v2");
MODULE_AUTHOR("David D'Ulisse");
MODULE_DESCRIPTION("Read a device tree");
